(function() {
  var inRange;

  inRange = require("./range");

  module.exports = function() {
    var hooks;
    hooks = {};
    return {
      add: function(aOperationType, aRange, hookProc) {
        var m;
        m = {
          range: range,
          hook: hook
        };
        if (hooks[aOperationType] == null) {
          hooks[aOperationType] = [];
        }
        hooks[aOperationType].push(m);
        return function() {
          var i;
          i = hooks[aOperationType].indexOf(m);
          if (~i) {
            return hooks[aOperationType].splice(i, 1);
          }
        };
      },
      removeAll: function(range) {
        if (range === undefined) {
          return hooks = {};
        } else {
          throw new Error("not implemented");
        }
      },
      free: function() {
        return hooks = null;
      },
      trigger: function(aOperationType, key, args) {
        var i, otHooks, results, test;
        i = 0;
        otHooks = hooks[aOperationType];
        if (otHooks) {
          results = [];
          while (i < otHooks.length) {
            test = otHooks[i];
            if (inRange(test.range, key)) {
              test.hook.apply(this, args);
            }
            results.push(i++);
          }
          return results;
        }
      }
    };
  };

}).call(this);

//# sourceMappingURL=hooks.js.map
