(function() {
  var SecondaryCache, SubkeyCache, inherits, minimatch, setImmediate;

  SecondaryCache = require("secondary-cache");

  minimatch = require('minimatch');

  inherits = require("inherits-ex/lib/inherits");

  setImmediate = setImmediate || process.nextTick;

  module.exports = SubkeyCache = (function() {
    inherits(SubkeyCache, SecondaryCache);

    function SubkeyCache() {
      SubkeyCache.__super__.constructor.apply(this, arguments);
    }

    SubkeyCache.prototype.createSubkey = function(keyPath, Subkey, options, callback) {
      var addRef, forceCreate, result;
      if (options) {
        forceCreate = options.forceCreate;
        addRef = options.addRef;
        delete options.forceCreate;
        delete options.addRef;
      }
      if (forceCreate === true) {
        result = new Subkey(options, callback);
      } else {
        result = this.get(keyPath);
        if (result) {
          if (callback) {
            setImmediate(callback.bind(result, null, result));
          }
        } else {
          result = new Subkey(options, callback);
          this.set(keyPath, result, options);
          result.on("destroyed", (function(_this) {
            return function(item) {
              return _this.del(keyPath);
            };
          })(this));
        }
        if (addRef !== false) {
          result.addRef();
        }
      }
      return result;
    };

    SubkeyCache.prototype.subkeys = function(aKeyPattern) {
      var result;
      result = {};
      if (aKeyPattern) {
        this.forEach(function(v, k) {
          if (minimatch(k, aKeyPattern)) {
            return result[k] = v;
          }
        });
      } else {
        this.forEach(function(v, k) {
          return result[k] = v;
        });
      }
      return result;
    };

    return SubkeyCache;

  })();

}).call(this);

//# sourceMappingURL=subkey-cache.js.map
