(function() {
  var Codec, EncodingIterator, GET_OP, SubkeyIterator, codec, consts, decodeKey, encodeKey, extend, inherits, isArray, lowerBound, ltgt, toLtgt, upperBound;

  ltgt = require('ltgt');

  EncodingIterator = require("encoding-iterator");

  inherits = require("abstract-object/lib/util/inherits");

  isArray = require("abstract-object/lib/util/isArray");

  extend = require("abstract-object/lib/util/_extend");

  Codec = require('buffer-codec');

  codec = require("./codec");

  consts = require("./consts");

  lowerBound = codec.lowerBound;

  upperBound = codec.upperBound;

  encodeKey = codec.encodeKey;

  decodeKey = codec.decodeKey;

  toLtgt = ltgt.toLtgt;

  GET_OP = consts.GET_OP;

  module.exports = SubkeyIterator = (function() {
    function SubkeyIterator() {}

    inherits(SubkeyIterator, EncodingIterator);

    SubkeyIterator.prototype.encodeOptions = function(options) {
      var encodeKeyPath, i, k, keyEncoding, len, ref, result, vOptions, vPath;
      vOptions = extend({}, options);
      vPath = options.path || [];
      options.valueEncoding = Codec(options.valueEncoding);
      options.keyEncoding = keyEncoding = Codec(options.keyEncoding);
      encodeKeyPath = function(key) {
        var encoding;
        encoding = key === lowerBound || key === upperBound ? null : keyEncoding;
        vOptions.path = options.path;
        return encodeKey(vPath, key, encoding, vOptions);
      };
      if (options.bounded !== false) {
        toLtgt(options, options, encodeKeyPath, lowerBound, upperBound);
      }
      options.keyAsBuffer = options.valueAsBuffer = false;
      if (isArray(options.range)) {
        result = [];
        ref = options.range;
        for (i = 0, len = ref.length; i < len; i++) {
          k = ref[i];
          vOptions.path = options.path;
          k = encodeKey(vPath, k, keyEncoding, vOptions, GET_OP);
          if (k !== false) {
            result.push(k);
          }
        }
        options.range = result;
      }
      return options;
    };

    SubkeyIterator.prototype.decodeResult = function(result) {
      var keyEncoding, valueEncoding;
      keyEncoding = this.options.keyEncoding;
      valueEncoding = this.options.valueEncoding;
      if (result[0] != null) {
        result[0] = decodeKey(result[0], keyEncoding, this.options);
      }
      if ((result[1] != null) && valueEncoding) {
        result[1] = valueEncoding.decode(result[1], this.options);
      }
      return result;
    };

    return SubkeyIterator;

  })();

}).call(this);

//# sourceMappingURL=subkey-iterator.js.map
